## GstGLViewConvert GstGLViewConvert — convert between steroscopic/multiview video formats |

## Functions

GstGLViewConvert * | gst_gl_view_convert_new ()
gboolean | gst_gl_view_convert_set_caps ()
GstCaps * | gst_gl_view_convert_transform_caps ()
GstCaps * | gst_gl_view_convert_fixate_caps ()
GstFlowReturn | gst_gl_view_convert_submit_input_buffer ()
GstFlowReturn | gst_gl_view_convert_get_output ()
GstBuffer * | gst_gl_view_convert_perform ()
void | gst_gl_view_convert_reset ()
void | gst_gl_view_convert_set_context ()

## Properties

GstGLStereoDownmix | downmix-mode | Read / Write
GstVideoMultiviewFlags | input-flags-override | Read / Write
GstVideoMultiviewMode | input-mode-override | Read / Write
GstVideoMultiviewFlags | output-flags-override | Read / Write
GstVideoMultiviewMode | output-mode-override | Read / Write

## Types and Values

enum | GstGLStereoDownmix
| GstGLViewConvert
| GstGLViewConvertClass

## Object Hierarchy

        GEnum
        ╰── GstGLStereoDownmix
        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstGLViewConvert

## Description

Convert stereoscopic/multiview video using fragment shaders.

## Functions

### gst_gl_view_convert_new ()

    GstGLViewConvert *
    gst_gl_view_convert_new (void);

#### Returns

a new GstGLViewConvert

Since: 1.6

### gst_gl_view_convert_set_caps ()

    gboolean
    gst_gl_view_convert_set_caps (GstGLViewConvert *viewconvert,
                                  GstCaps *in_caps,
                                  GstCaps *out_caps);

Initializes `viewconvert` with the information required for conversion.

#### Parameters

viewconvert | a GstGLViewConvert |
in_caps | input GstCaps |
out_caps | output GstCaps |

Since: 1.6

### gst_gl_view_convert_transform_caps ()

    GstCaps *
    gst_gl_view_convert_transform_caps (GstGLViewConvert *viewconvert,
                                        GstPadDirection direction,
                                        GstCaps *caps,
                                        GstCaps *filter);

Provides an implementation of `GstBaseTransformClass::`transform_caps()``

#### Parameters

viewconvert | a GstGLViewConvert |
direction | a GstPadDirection |
caps | the GstCaps to transform. | [transfer none]
filter | a set of filter GstCaps. | [transfer none]

#### Returns

the converted GstCaps.

[transfer full]

Since: 1.6

### gst_gl_view_convert_fixate_caps ()

    GstCaps *
    gst_gl_view_convert_fixate_caps (GstGLViewConvert *viewconvert,
                                     GstPadDirection direction,
                                     GstCaps *caps,
                                     GstCaps *othercaps);

Provides an implementation of `GstBaseTransformClass::`fixate_caps()``

#### Parameters

viewconvert | a GstGLViewConvert |
direction | a GstPadDirection |
caps | the GstCaps of `direction` . | [transfer none]
othercaps | the GstCaps to fixate. | [transfer full]

#### Returns

the fixated GstCaps.

[transfer full]

Since: 1.6

### gst_gl_view_convert_submit_input_buffer ()

    GstFlowReturn
    gst_gl_view_convert_submit_input_buffer
                                   (GstGLViewConvert *viewconvert,
                                    gboolean is_discont,
                                    GstBuffer *input);

Submit `input` to be processed by `viewconvert`

#### Parameters

viewconvert | a GstGLViewConvert |
is_discont | true if we have a discontinuity |
input | a GstBuffer. | [transfer full]

#### Returns

a GstFlowReturn

Since: 1.6

### gst_gl_view_convert_get_output ()

    GstFlowReturn
    gst_gl_view_convert_get_output (GstGLViewConvert *viewconvert,
                                    GstBuffer **outbuf_ptr);

Retrieve the processed output buffer placing the output in `outbuf_ptr` .

#### Parameters

viewconvert | a GstGLViewConvert |
outbuf_ptr | a GstBuffer. | [out]

#### Returns

a GstFlowReturn

Since: 1.6

### gst_gl_view_convert_perform ()

    GstBuffer *
    gst_gl_view_convert_perform (GstGLViewConvert *viewconvert,
                                 GstBuffer *inbuf);

Converts the data contained by `inbuf` using the formats specified by the GstCaps passed to `gst_gl_view_convert_set_caps()`

#### Parameters

viewconvert | a GstGLViewConvert |
inbuf | the GstGLMemory filled GstBuffer to convert. | [transfer none]

#### Returns

a converted GstBuffer or `NULL`.

[transfer full]

Since: 1.6

### gst_gl_view_convert_reset ()

    void
    gst_gl_view_convert_reset (GstGLViewConvert *viewconvert);

Reset `viewconvert` to the default state. Further operation will require setting the caps with `gst_gl_view_convert_set_caps()`.

#### Parameters

viewconvert | a GstGLViewConvert |

Since: 1.6

### gst_gl_view_convert_set_context ()

    void
    gst_gl_view_convert_set_context (GstGLViewConvert *viewconvert,
                                     GstGLContext *context);

Set `context` on `viewconvert`

#### Parameters

viewconvert | a GstGLViewConvert |
context | the GstGLContext to set |

Since: 1.6

## Types and Values

### enum GstGLStereoDownmix

Output anaglyph type to generate when downmixing to mono

#### Members

GST_GL_STEREO_DOWNMIX_ANAGLYPH_GREEN_MAGENTA_DUBOIS | Dubois optimised Green-Magenta anaglyph |
GST_GL_STEREO_DOWNMIX_ANAGLYPH_RED_CYAN_DUBOIS | Dubois optimised Red-Cyan anaglyph |
GST_GL_STEREO_DOWNMIX_ANAGLYPH_AMBER_BLUE_DUBOIS | Dubois optimised Amber-Blue anaglyph |

### GstGLViewConvert

    typedef struct _GstGLViewConvert GstGLViewConvert;

GstGLViewConvert is an opaque struct and should only be accessed through the provided api.

### GstGLViewConvertClass

    typedef struct {
    } GstGLViewConvertClass;

Opaque GstGLViewConvertClass struct

## Property Details

### The `“downmix-mode”` property

      “downmix-mode”             GstGLStereoDownmix

Output anaglyph type to generate when downmixing to mono.

Flags: Read / Write

Default value: Dubois optimised Green-Magenta anaglyph

### The `“input-flags-override”` property

      “input-flags-override”     GstVideoMultiviewFlags

Override any input information about multiview layout flags.

Flags: Read / Write

### The `“input-mode-override”` property

      “input-mode-override”      GstVideoMultiviewMode

Override any input information about multiview layout.

Flags: Read / Write

Default value: GST_VIDEO_MULTIVIEW_MODE_NONE

### The `“output-flags-override”` property

      “output-flags-override”    GstVideoMultiviewFlags

Override automatic negotiation for output multiview layout flags.

Flags: Read / Write

### The `“output-mode-override”` property

      “output-mode-override”     GstVideoMultiviewMode

Override automatic output mode selection for multiview layout.

Flags: Read / Write

Default value: GST_VIDEO_MULTIVIEW_MODE_NONE

## See Also

GstGLColorConvert, GstGLContext